
import ddf.minim.*;
Minim minim;
AudioPlayer player;

final int kale=1;

//import processing.sound.*;

PImage p;
PGraphics g;
PFont f;

String txt[]={
  " ",
  "Ai ko tulikin hiano!",
  "The Fiture Crew lahjoittaa",
  "Baskivinaani",
  "Koskivinaanibala?",
  "Kaskibanaanivola...",
  
  "Vaskibonaanikila!",
  "Ja ihan vaan tiedoksi,",
  "että meitsi ei tod. halua",
  "Kootikelminä touhusi Märq",
  "Mussiikkit mäjjäytti Røz",
  
  "Ja sitte vielä:",
  "Greetings to Heppo!",
  " "
};

class Part
{
  float x,y,dx,dy,dex,dey,r;
  
  int c;
  
  Part(float cx,float cy,float destx,float desty,int col,int rad)
  {
    x=cx;
    y=cy;
    dex=destx;
    dey=desty;
    c=col;
    r=rad/kale;
    
    dx=(destx-cx)/80.0;
    dy=(desty-cy)/80.0;
  }
  
  boolean update()
  {
    x+=dx;
    y+=dy;

    fill(c);
    ellipse(x,y,r,r);
        
    if(abs(x-dex)<1 && abs(y-dey)<1)
    {
      g.fill(c);
      g.ellipse(dex,dey,r,r);
      return false;
    }
    
    return true;
  }
}

ArrayList<Part> arr=new ArrayList();
int alko=-1;

void setup()
{
  frameRate(60);
  size(1920/kale,1080/kale,P2D);
  background(30);
  noStroke();
  noCursor();
  
  g=createGraphics(width,height,P2D);
  g.beginDraw();
  g.background(30);
  g.noStroke();
  g.endDraw();
  
  p=loadImage("viskibanaani.png");
  p.loadPixels();
  
  f=loadFont("vuonti.vlw");
  textFont(f,40/kale);
  textAlign(CENTER);
  
  minim=new Minim(this);
  player=minim.loadFile("sammalta_katolla.mp3");
  player.play();
  alko=millis();
}

int sais=0;

void draw()
{
  float x,y;
  int rx,ry;

  int tid=millis()-alko;

  image(g,0,0);

  x=width/2+sin((float)tid*0.0003)*900/kale;
  y=height/2+cos((float)tid*0.0004)*600/kale;
  sais=85-tid/1000;
  if(sais<9)
    sais=9;

  int uus=tid/120;
  uus=1+uus*uus/100000;

  for(int i=0;tid<1000*134 && i<uus;i++)
  {
    rx=(int)random(width);
    ry=(int)random(height);
    Part pa=new Part(x,y,rx,ry,p.pixels[rx*kale+ry*kale*width*kale]&0xf0ffffff,sais);
    arr.add(pa);
  }
  
  g.beginDraw();
  for(int i=0;i<arr.size();i++)
  {
    Part b=arr.get(i);
    if(!b.update())
    {
      arr.remove(i);
      i--;
    }
  } 
  g.endDraw();
  
  stroke(0);
  strokeWeight(2/kale);
  line(x,0,x,height);
  line(0,y,width,y);
  noStroke();
  
  // Writeri
  fill(0);
  rect(0,900/kale,width,64/kale); 
  fill(255,255,240);

  int idx=tid/10000;
  if(idx>=txt.length)
    idx=txt.length-1;
  
  int lenkki=tid%10000/150;
  if(lenkki>=txt[idx].length())
    lenkki=txt[idx].length();
    
  int ohs=0;
  if(tid%10000>7000)
  {
    ohs=tid%10000-7000;
    if(tid/10000%2==0)
      ohs=-ohs;
  }
  ohs/=kale;
   
  text(txt[idx].substring(0,lenkki),width/2+ohs,945/kale);
  
  if(tid<1000*134 && tid%4800>100 && tid%4800<250)
  {
    loadPixels();
    for(int i=0;i<width*height;i++)
      pixels[i]=(0xffffff-(pixels[i]&0xffffff))+0xff000000;
    updatePixels();
  }
  
  if(tid>1000*140)
    exit();
}

